var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Twinkle } from './twinkle';
/**
 * Wrapper around Morebits.wiki.api that preset the commonly used
 * API parameters and sets the correct user agent
 */
var Api = /** @class */ (function (_super) {
    __extends(Api, _super);
    function Api(currentAction, query, statusElement) {
        var _this = this;
        query = $.extend({
            action: 'query',
            format: 'json',
            formatversion: '2',
            uselang: Twinkle.language,
            errorlang: Twinkle.language,
            errorsuselocal: true,
            // tags isn't applicable for all API actions, it gives a warning but that's harmless
            tags: Twinkle.changeTags,
        }, query);
        _this = _super.call(this, currentAction, query, null, statusElement, null) || this;
        return _this;
    }
    Api.prototype.post = function (ajaxParameters) {
        if (!ajaxParameters) {
            ajaxParameters = {};
        }
        if (!ajaxParameters.headers) {
            ajaxParameters.headers = {};
        }
        ajaxParameters.headers['Api-User-Agent'] = Twinkle.userAgent;
        return _super.prototype.post.call(this, ajaxParameters);
    };
    return Api;
}(Morebits.wiki.api));
export { Api };
export var mwApi;
/**
 * Called from init(). Can't initialise at top level, since values of
 * Twinkle.* aren't final by that stage.
 * @private
 */
export function initialiseMwApi() {
    mwApi = new mw.Api({
        parameters: {
            action: 'query',
            format: 'json',
            formatversion: '2',
            uselang: Twinkle.language,
            errorlang: Twinkle.language,
            errorsuselocal: true,
            // tags isn't applicable for all API actions, it gives a warning but that's harmless
            tags: Twinkle.changeTags,
        },
        ajax: {
            headers: {
                'Api-User-Agent': Twinkle.userAgent,
            },
        },
    });
}
//# sourceMappingURL=Api.js.map