var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Twinkle } from './twinkle';
import { obj_entries } from './utils';
/**
 * Light wrapper around Morebits.simpleWindow
 * that sets the script name (Twinkle) and provides
 * a method to set footer links at once
 */
var Dialog = /** @class */ (function (_super) {
    __extends(Dialog, _super);
    function Dialog(width, height) {
        var _this = _super.call(this, width, height) || this;
        _this.setScriptName(Twinkle.scriptName);
        return _this;
    }
    Dialog.prototype.setFooterLinks = function (links) {
        var _this = this;
        if (!links) {
            return;
        }
        obj_entries(links).forEach(function (link) {
            _this.addFooterLink(link[0], link[1]);
        });
    };
    return Dialog;
}(Morebits.simpleWindow));
export { Dialog };
//# sourceMappingURL=Dialog.js.map