var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Twinkle } from './twinkle';
import { ApiError } from './utils';
/**
 * Light but immensely hacky wrapper around Morebits.wiki.user that presets the
 * change tags and promisifies the core methods.
 */
var User = /** @class */ (function (_super) {
    __extends(User, _super);
    function User(userName, status) {
        var _this = _super.call(this, userName, status) || this;
        // If changeTags is configured, apply it, otherwise override setReason
        // so that it appends the summaryAd
        if (Twinkle.changeTags.length) {
            // checks out if changeTags is a non-empty string or a non-empty array
            _this.setChangeTags(Twinkle.changeTags);
        }
        else {
            var setReasonOriginal_1 = _this.setReason.bind(_this);
            _this.setReason = function (summary) {
                setReasonOriginal_1(summary + Twinkle.summaryAd);
            };
        }
        // This is ugly, because Morebits.wiki.user uses an implementation pattern
        // that doesn't define any methods on Morebits.wiki.user.prototype.
        var functionsToPromisify = ['load', 'block', 'notify'];
        functionsToPromisify.forEach(function (func) {
            // TODO: check return argument types
            var origFunc = _this[func].bind(_this);
            _this[func] = function (onSuccess, onFailure) {
                var _this = this;
                var def = $.Deferred();
                origFunc(function (arg) {
                    if (onSuccess) {
                        onSuccess.call(_this, // pass context as this, mostly needed everywhere
                        _this // pass first arg as this, only needed for fnAutoSave
                        // which takes pageobj as argument
                        );
                    }
                    // try to resolve with the api object
                    def.resolve(arg instanceof Morebits.wiki.api ? arg : _this);
                }, function (arg) {
                    if (onFailure) {
                        onFailure.call(_this, _this); // same as above
                    }
                    if (arg instanceof Morebits.wiki.api) {
                        var err = new ApiError(arg.getErrorCode() + ': ' + arg.getErrorText());
                        err.code = arg.getErrorCode();
                        err.info = arg.getErrorText();
                        err.response = arg.getResponse();
                        def.reject(err);
                    }
                    else {
                        def.reject(new Error(arg));
                    }
                });
                return def;
            };
        });
        return _this;
    }
    return User;
}(Morebits.wiki.user));
export { User };
//# sourceMappingURL=User.js.map