var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Api } from '../Api';
import { TwinkleModule } from '../twinkleModule';
import { addPortletLink } from '../portlet';
import { msg } from '../messenger';
/**
 * Diff module: shows a link to last edit on all pages.
 * On diff pages, shows a link to a diff of edits since your last edit,
 * and a diff of the version compared to the current version.
 *
 * Localisation: should work without any configuration.
 */
var DiffCore = /** @class */ (function (_super) {
    __extends(DiffCore, _super);
    function DiffCore() {
        var _this = _super.call(this) || this;
        if (mw.config.get('wgNamespaceNumber') < 0 || !mw.config.get('wgArticleId')) {
            return _this;
        }
        addPortletLink(mw.util.getUrl(mw.config.get('wgPageName'), {
            diff: 'cur',
            oldid: 'prev',
        }), msg('diff-last'), 'twinkle-lastdiff', msg('diff-last-tooltip'));
        // Show additional tabs only on diff pages
        if (!mw.util.getParamValue('diff')) {
            return _this;
        }
        addPortletLink(function () { return _this.evaluate(false); }, msg('diff-since'), 'tw-since', msg('diff-since-tooltip'));
        addPortletLink(function () { return _this.evaluate(true); }, msg('diff-sincemine'), 'tw-sincemine', msg('diff-sincemine-tooltip'));
        addPortletLink(mw.util.getUrl(mw.config.get('wgPageName'), {
            diff: 'cur',
            oldid: /oldid=(.+)/.exec($('#mw-diff-ntitle1').find('strong a').first().attr('href'))[1],
        }), msg('diff-current'), 'tw-curdiff', msg('diff-current-tooltip'));
        return _this;
    }
    DiffCore.prototype.evaluate = function (me) {
        var user;
        if (me) {
            user = mw.config.get('wgUserName');
        }
        else {
            var node = document.getElementById('mw-diff-ntitle2');
            if (!node) {
                // nothing to do?
                return;
            }
            user = $(node).find('a').first().text();
        }
        Morebits.status.init(document.getElementById('mw-content-text'));
        var wikipedia_api = new Api('Grabbing data of initial contributor', {
            prop: 'revisions',
            action: 'query',
            titles: mw.config.get('wgPageName'),
            rvlimit: 1,
            rvprop: ['ids', 'user'],
            rvstartid: mw.config.get('wgCurRevisionId') - 1,
            rvuser: user,
            format: 'json',
        });
        wikipedia_api.post().then(function (apiobj) {
            var rev = apiobj.getResponse().query.pages[0].revisions;
            var revid = rev && rev[0].revid;
            if (!revid) {
                apiobj.getStatusElement().error(msg('diff-error', user));
                return;
            }
            window.location.href = mw.util.getUrl(mw.config.get('wgPageName'), {
                diff: mw.config.get('wgCurRevisionId'),
                oldid: revid,
            });
        });
        wikipedia_api.post();
    };
    DiffCore.moduleName = 'Diff';
    return DiffCore;
}(TwinkleModule));
export { DiffCore };
//# sourceMappingURL=diffCore.js.map