var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Twinkle } from '../twinkle';
import { msg } from '../messenger';
import { TwinkleModule } from '../twinkleModule';
import { getPref } from '../Config';
/**
 * "Fluff" module is used for reverting vandalism. It offers several types of
 * revert modes.
 *
 * **Localisation**: You may wish to customise {@link trustedBots}.
 * Apart from that, this module should work without any further configuration.
 */
var Fluff = /** @class */ (function (_super) {
    __extends(Fluff, _super);
    function Fluff() {
        var _this = _super.call(this) || this;
        _this.moduleName = 'fluff';
        _this.skipTalk = null;
        _this.rollbackInPlace = null;
        _this.flaggedRevsEnabled = !!mw.loader.moduleRegistry['ext.flaggedRevs.basic'];
        // Consolidated construction of fluff links
        _this.linkBuilder = {
            spanTag: function (color, content) {
                var span = document.createElement('span');
                span.style.color = color;
                span.appendChild(document.createTextNode(content));
                return span;
            },
            buildLink: function (color, text) {
                var link = document.createElement('a');
                link.appendChild(_this.linkBuilder.spanTag('Black', '['));
                link.appendChild(_this.linkBuilder.spanTag(color, text));
                link.appendChild(_this.linkBuilder.spanTag('Black', ']'));
                link.href = '#';
                return link;
            },
            /**
             * @param {string} [vandal=null] - Username of the editor being reverted
             * Provide a falsey value if the username is hidden, defaults to null
             * @param {boolean} inline - True to create two links in a span, false
             * to create three links in a div (optional)
             * @param {number|string} [rev=wgCurRevisionId] - Revision ID being reverted (optional)
             * @param {string} [page=wgPageName] - Page being reverted (optional)
             */
            rollbackLinks: function (vandal, inline, rev, page) {
                if (inline === void 0) { inline = false; }
                vandal = vandal || null;
                var elem = inline ? 'span' : 'div';
                var revNode = document.createElement(elem);
                rev = parseInt(rev, 10);
                if (rev) {
                    revNode.setAttribute('id', 'tw-revert' + rev);
                }
                else {
                    revNode.setAttribute('id', 'tw-revert');
                }
                var normNode = document.createElement('strong');
                var vandNode = document.createElement('strong');
                var normLink = _this.linkBuilder.buildLink('SteelBlue', msg('link-rollback'));
                var vandLink = _this.linkBuilder.buildLink('Red', msg('link-vandalism'));
                $(normLink).click(function () {
                    _this.revert('norm', vandal, rev, page);
                    _this.disableLinks(revNode);
                });
                $(vandLink).click(function () {
                    _this.revert('vand', vandal, rev, page);
                    _this.disableLinks(revNode);
                });
                vandNode.appendChild(vandLink);
                normNode.appendChild(normLink);
                var separator = inline ? ' ' : ' || ';
                if (!inline) {
                    var agfNode = document.createElement('strong');
                    var agfLink = _this.linkBuilder.buildLink('DarkOliveGreen', msg('link-goodfaith-rollback'));
                    $(agfLink).click(function () {
                        _this.revert('agf', vandal, rev, page);
                        // this.disableLinks(revNode); // rollbackInPlace not relevant for any inline situations
                    });
                    agfNode.appendChild(agfLink);
                    revNode.appendChild(agfNode);
                }
                revNode.appendChild(document.createTextNode(separator));
                revNode.appendChild(normNode);
                revNode.appendChild(document.createTextNode(separator));
                revNode.appendChild(vandNode);
                return revNode;
            },
            // Build [restore this revision] links
            restoreThisRevisionLink: function (revisionRef, inline) {
                if (inline === void 0) { inline = false; }
                // If not a specific revision number, should be wgDiffNewId/wgDiffOldId/wgRevisionId
                revisionRef = typeof revisionRef === 'number' ? revisionRef : mw.config.get(revisionRef);
                var elem = inline ? 'span' : 'div';
                var revertToRevisionNode = document.createElement(elem);
                revertToRevisionNode.setAttribute('id', 'tw-revert-to-' + revisionRef);
                revertToRevisionNode.style.fontWeight = 'bold';
                var revertToRevisionLink = _this.linkBuilder.buildLink('SaddleBrown', msg('restore-revision'));
                $(revertToRevisionLink).click(function () {
                    _this.revertToRevision(revisionRef);
                });
                if (inline) {
                    revertToRevisionNode.appendChild(document.createTextNode(' '));
                }
                revertToRevisionNode.appendChild(revertToRevisionLink);
                return revertToRevisionNode;
            },
        };
        _this.addLinks = {
            contributions: function () {
                // $('sp-contributions-footer-anon-range') relies on the fmbox
                // id in [[MediaWiki:Sp-contributions-footer-anon-range]] and
                // is used to show rollback/vandalism links for IP ranges
                var isRange = !!$('#sp-contributions-footer-anon-range')[0];
                if (mw.config.exists('wgRelevantUserName') || isRange) {
                    // Get the username these contributions are for
                    var username = mw.config.get('wgRelevantUserName');
                    if (getPref('showRollbackLinks').indexOf('contribs') !== -1 ||
                        (mw.config.get('wgUserName') !== username && getPref('showRollbackLinks').indexOf('others') !== -1) ||
                        (mw.config.get('wgUserName') === username && getPref('showRollbackLinks').indexOf('mine') !== -1)) {
                        var $list = $('#mw-content-text').find('ul li:has(span.mw-uctop):has(.mw-changeslist-diff)');
                        $list.each(function (key, current) {
                            // revid is also available in the href of both
                            // .mw-changeslist-date or .mw-changeslist-diff
                            var page = $(current).find('.mw-contributions-title').text();
                            // Get username for IP ranges (wgRelevantUserName is null)
                            if (isRange) {
                                // The :not is possibly unnecessary, as it appears that
                                // .mw-userlink is simply not present if the username is hidden
                                username = $(current).find('.mw-userlink:not(.history-deleted)').text();
                            }
                            // It's unlikely, but we can't easily check for revdel'd usernames
                            // since only a strong element is provided, with no easy selector [[phab:T255903]]
                            current.appendChild(_this.linkBuilder.rollbackLinks(username, true, current.dataset.mwRevid, page));
                        });
                    }
                }
            },
            recentchanges: function () {
                if (getPref('showRollbackLinks').indexOf('recent') !== -1) {
                    // Latest and revertable (not page creations, logs, categorizations, etc.)
                    var $list = $('.mw-changeslist .mw-changeslist-last.mw-changeslist-src-mw-edit');
                    // Exclude top-level header if "group changes" preference is used
                    // and find only individual lines or nested lines
                    $list = $list
                        .not('.mw-rcfilters-ui-highlights-enhanced-toplevel')
                        .find('.mw-changeslist-line-inner, td.mw-enhanced-rc-nested');
                    $list.each(function (key, current) {
                        // The :not is possibly unnecessary, as it appears that
                        // .mw-userlink is simply not present if the username is hidden
                        var vandal = $(current).find('.mw-userlink:not(.history-deleted)').text();
                        var href = $(current).find('.mw-changeslist-diff').attr('href');
                        var rev = mw.util.getParamValue('diff', href);
                        var page = current.dataset.targetPage;
                        current.appendChild(_this.linkBuilder.rollbackLinks(vandal, true, rev, page));
                    });
                }
            },
            history: function () {
                if (getPref('showRollbackLinks').indexOf('history') !== -1) {
                    // All revs
                    var histList = $('#pagehistory li').toArray();
                    // On first page of results, so add revert/rollback
                    // links to the top revision
                    if (!$('.mw-firstlink').length) {
                        var first = histList.shift();
                        var vandal = $(first).find('.mw-userlink:not(.history-deleted)').text();
                        // Check for first username different than the top user,
                        // only apply rollback links if/when found
                        // for faster than every
                        for (var i = 0; i < histList.length; i++) {
                            if ($(histList[i]).find('.mw-userlink').text() !== vandal) {
                                first.appendChild(_this.linkBuilder.rollbackLinks(vandal, true));
                                break;
                            }
                        }
                    }
                    // oldid
                    histList.forEach(function (rev) {
                        // From restoreThisRevision, non-transferable
                        // If the text has been revdel'd, it gets wrapped in a span with .history-deleted,
                        // and href will be undefined (and thus oldid is NaN)
                        var href = rev.querySelector('.mw-changeslist-date').href;
                        var oldid = parseInt(mw.util.getParamValue('oldid', href), 10);
                        if (!isNaN(oldid)) {
                            rev.appendChild(_this.linkBuilder.restoreThisRevisionLink(oldid, true));
                        }
                    });
                }
            },
            diff: function () {
                // Autofill user talk links on diffs with vanarticle for easy warning, but don't autowarn
                var warnFromTalk = function (xtitle) {
                    var talkLink = $('#mw-diff-' + xtitle + '2 .mw-usertoollinks a').first();
                    if (talkLink.length) {
                        var extraParams = 'vanarticle=' + mw.util.rawurlencode(Morebits.pageNameNorm) + '&' + 'noautowarn=true';
                        // diffIDs for vanarticlerevid
                        extraParams += '&vanarticlerevid=';
                        extraParams += xtitle === 'otitle' ? mw.config.get('wgDiffOldId') : mw.config.get('wgDiffNewId');
                        var href = talkLink.attr('href');
                        if (href.indexOf('?') === -1) {
                            talkLink.attr('href', href + '?' + extraParams);
                        }
                        else {
                            talkLink.attr('href', href + '&' + extraParams);
                        }
                    }
                };
                // Older revision
                warnFromTalk('otitle'); // Add quick-warn link to user talk link
                // Don't load if there's a single revision or weird diff (cur on latest)
                if (mw.config.get('wgDiffOldId') && mw.config.get('wgDiffOldId') !== mw.config.get('wgDiffNewId')) {
                    // Add a [restore this revision] link to the older revision
                    var oldTitle = document.getElementById('mw-diff-otitle1').parentNode;
                    oldTitle.insertBefore(_this.linkBuilder.restoreThisRevisionLink('wgDiffOldId'), oldTitle.firstChild);
                }
                // Newer revision
                warnFromTalk('ntitle'); // Add quick-warn link to user talk link
                // Add either restore or rollback links to the newer revision
                // Don't show if there's a single revision or weird diff (prev on first)
                if (document.getElementById('differences-nextlink')) {
                    // Not latest revision, add [restore this revision] link to newer revision
                    var newTitle = document.getElementById('mw-diff-ntitle1').parentNode;
                    newTitle.insertBefore(_this.linkBuilder.restoreThisRevisionLink('wgDiffNewId'), newTitle.firstChild);
                }
                else if (getPref('showRollbackLinks').indexOf('diff') !== -1 &&
                    mw.config.get('wgDiffOldId') &&
                    (mw.config.get('wgDiffOldId') !== mw.config.get('wgDiffNewId') ||
                        document.getElementById('differences-prevlink'))) {
                    // Normally .mw-userlink is a link, but if the
                    // username is hidden, it will be a span with
                    // .history-deleted as well. When a sysop views the
                    // hidden content, the span contains the username in a
                    // link element, which will *just* have
                    // .mw-userlink. The below thus finds the first
                    // instance of the class, which if hidden is the span
                    // and thus text returns undefined. Technically, this
                    // is a place where sysops *could* have more
                    // information available to them (as above, via
                    // &unhide=1), since the username will be available by
                    // checking a.mw-userlink instead, but revert() will
                    // need reworking around userHidden
                    var vandal = $('#mw-diff-ntitle2').find('.mw-userlink')[0].textContent;
                    var ntitle = document.getElementById('mw-diff-ntitle1').parentNode;
                    ntitle.insertBefore(_this.linkBuilder.rollbackLinks(vandal), ntitle.firstChild);
                }
            },
            oldid: function () {
                // Add a [restore this revision] link on old revisions
                var title = document.getElementById('mw-revision-info').parentNode;
                title.insertBefore(_this.linkBuilder.restoreThisRevisionLink('wgRevisionId'), title.firstChild);
            },
        };
        _this.callbacks = {
            toRevision: function (pageobj) {
                var optional_summary = prompt(msg('prompt-reason-restore'), ''); // padded out to widen prompt in Firefox
                if (optional_summary === null) {
                    pageobj.getStatusElement().error(msg('user-aborted'));
                    return;
                }
                var summary = _this.formatSummary(msg('restore-summary', pageobj.getRevisionID()), pageobj.getRevisionUser(), optional_summary);
                pageobj.setChangeTags(Twinkle.changeTags);
                pageobj.setEditSummary(summary);
                if (getPref('watchRevertedPages').indexOf('torev') !== -1) {
                    pageobj.setWatchlist(getPref('watchRevertedExpiry'));
                }
                if (getPref('markRevertedPagesAsMinor').indexOf('torev') !== -1) {
                    pageobj.setMinorEdit(true);
                }
                Morebits.wiki.actionCompleted.redirect = pageobj.getPageName();
                Morebits.wiki.actionCompleted.notice = msg('reversion-complete');
                pageobj.revert();
            },
            main: function (apiobj) {
                var page = apiobj.getResponse().query.pages[0];
                if (!page.actions.edit) {
                    apiobj.statelem.error(msg('cant-edit-protected'));
                    return;
                }
                var statelem = apiobj.statelem;
                var params = apiobj.params;
                var lastrevid = parseInt(page.lastrevid, 10);
                var revs = page.revisions;
                if (revs.length < 1) {
                    statelem.error(msg('no-revisions'));
                    return;
                }
                var top = revs[0];
                var lastuser = top.user;
                // Should be handled by the API, but nice to quit early
                if (lastrevid < params.revid) {
                    Morebits.status.error('Error', msg('bad-revid', lastrevid));
                    return;
                }
                // Used for user-facing alerts, messages, etc., not edits or summaries
                var userNorm = params.user || msg('hidden-user');
                var index = 1;
                if (params.revid !== lastrevid) {
                    Morebits.status.warn('Warning', msg('revid-mismatch', lastrevid, params.revid));
                    // Treat ipv6 users on same 64 block as the same
                    if (lastuser === params.user ||
                        (mw.util.isIPv6Address(params.user) && Morebits.ip.get64(lastuser) === Morebits.ip.get64(params.user))) {
                        switch (params.type) {
                            case 'vand':
                                if (lastuser !== params.user) {
                                    Morebits.status.info('Info', msg('latest-rev-same-64', userNorm));
                                }
                                else {
                                    Morebits.status.info('Info', msg('latest-rev-same-user', userNorm));
                                }
                                break;
                            case 'agf':
                                Morebits.status.warn('Warning', msg('latest-rev-other-user-goodfaith', userNorm));
                                return;
                            default:
                                Morebits.status.warn('Notice', msg('latest-rev-other-user', userNorm));
                                return;
                        }
                    }
                    else if (params.type === 'vand' &&
                        // Okay to test on user since it will either fail or sysop will correctly access it
                        // Besides, none of the trusted bots are going to be revdel'd
                        _this.trustedBots.indexOf(top.user) !== -1 &&
                        revs.length > 1 &&
                        revs[1].revid === params.revid) {
                        Morebits.status.info('Info', msg('latest-rev-bot', lastuser));
                        index = 2;
                    }
                    else {
                        Morebits.status.error('Error', msg('latest-rev-reverted', lastuser));
                        return;
                    }
                }
                else {
                    // Expected revision is the same, so the users must match;
                    // this allows sysops to know whether the users are the same
                    params.user = lastuser;
                    userNorm = params.user || msg('hidden-user');
                }
                if (_this.trustedBots.indexOf(params.user) !== -1) {
                    switch (params.type) {
                        case 'vand':
                            Morebits.status.info('Info', msg('bot-revert', userNorm));
                            index = 2;
                            params.user = revs[1].user;
                            params.userHidden = !!revs[1].userhidden;
                            break;
                        case 'agf':
                            Morebits.status.warn('Notice', msg('bot-revert-goodfaith', userNorm));
                            return;
                        case 'norm':
                        /* falls through */
                        default:
                            var cont = confirm(msg('bot-revert-prompt'));
                            if (cont) {
                                Morebits.status.info('Info', msg('bot-revert-previous', userNorm));
                                index = 2;
                                params.user = revs[1].user;
                                params.userHidden = !!revs[1].userhidden;
                                userNorm = params.user || msg('hidden-user');
                            }
                            else {
                                Morebits.status.warn('Notice', msg('bot-revert-selected', userNorm));
                            }
                            break;
                    }
                }
                var found = false;
                var count = 0;
                var seen64 = false;
                for (var i = index; i < revs.length; ++i) {
                    ++count;
                    if (revs[i].user !== params.user) {
                        // Treat ipv6 users on same 64 block as the same
                        if (mw.util.isIPv6Address(revs[i].user) &&
                            Morebits.ip.get64(revs[i].user) === Morebits.ip.get64(params.user)) {
                            if (!seen64) {
                                new Morebits.status('Note', msg('ipv6-same-user'));
                                seen64 = true;
                            }
                            continue;
                        }
                        found = i;
                        break;
                    }
                }
                if (!found) {
                    statelem.error(msg('no-previous-revision', userNorm, getPref('revertMaxRevisions')));
                    return;
                }
                if (!count) {
                    Morebits.status.error('Error', msg('no-edits-revert'));
                    return;
                }
                var good_revision = revs[found];
                var userHasAlreadyConfirmedAction = false;
                if (params.type !== 'vand' && count > 1) {
                    if (!confirm(msg('revert-multiple-prompt', userNorm, count))) {
                        Morebits.status.info('Notice', msg('stopping'));
                        return;
                    }
                    userHasAlreadyConfirmedAction = true;
                }
                params.count = count;
                params.goodid = good_revision.revid;
                params.gooduser = good_revision.user;
                params.gooduserHidden = !!good_revision.userhidden;
                statelem.status(msg('revision-age', params.goodid, count, params.gooduserHidden ? msg('hidden-user') : params.gooduser));
                var summary, extra_summary;
                switch (params.type) {
                    case 'agf':
                        extra_summary = prompt(msg('summary-prompt'), ''); // padded out to widen prompt in Firefox
                        if (extra_summary === null) {
                            statelem.error(msg('user-aborted'));
                            return;
                        }
                        userHasAlreadyConfirmedAction = true;
                        summary = _this.formatSummary(msg('goodfaith-summary'), // %USER% will be replaced by username
                        params.userHidden ? null : params.user, extra_summary);
                        break;
                    case 'vand':
                        summary = _this.formatSummary(msg('vandalism-summary', params.count, params.gooduserHidden ? msg('hidden-user') : params.gooduser), params.userHidden ? null : params.user);
                        break;
                    case 'norm':
                    /* falls through */
                    default:
                        if (getPref('offerReasonOnNormalRevert')) {
                            extra_summary = prompt(msg('summary-prompt'), ''); // padded out to widen prompt in Firefox
                            if (extra_summary === null) {
                                statelem.error(msg('user-aborted'));
                                return;
                            }
                            userHasAlreadyConfirmedAction = true;
                        }
                        summary = _this.formatSummary(msg('normal-summary', params.count), params.userHidden ? null : params.user, extra_summary);
                        break;
                }
                if ((getPref('confirmOnFluff') ||
                    // Mobile user agent taken from [[en:MediaWiki:Gadget-confirmationRollback-mobile.js]]
                    (getPref('confirmOnMobileFluff') &&
                        /Android|webOS|iPhone|iPad|iPod|BlackBerry|Mobile|Opera Mini/i.test(navigator.userAgent))) &&
                    !userHasAlreadyConfirmedAction &&
                    !confirm(msg('revert-confirm'))) {
                    statelem.error(msg('user-aborted'));
                    return;
                }
                // Decide whether to notify the user on success
                if (!_this.skipTalk &&
                    getPref('openTalkPage').indexOf(params.type) !== -1 &&
                    !params.userHidden &&
                    mw.config.get('wgUserName') !== params.user) {
                    params.notifyUser = true;
                    // Pass along to the warn module
                    params.vantimestamp = top.timestamp;
                }
                // figure out whether we need to/can review the edit
                if (_this.flaggedRevsEnabled &&
                    // XXX: user group
                    (Morebits.userIsInGroup('reviewer') || Morebits.userIsSysop) &&
                    !!page.flagged &&
                    page.flagged.stable_revid >= params.goodid &&
                    !!page.flagged.pending_since) {
                    params.reviewRevert = true;
                    params.csrftoken = apiobj.getResponse().query.tokens.csrftoken;
                }
                var revertPage = new Morebits.wiki.page(params.pagename, msg('saving-reverted'));
                revertPage.setEditSummary(summary);
                revertPage.setChangeTags(Twinkle.changeTags);
                revertPage.setOldID(params.goodid);
                revertPage.setCallbackParameters(params);
                if (getPref('watchRevertedPages').indexOf(params.type) !== -1) {
                    revertPage.setWatchlist(getPref('watchRevertedExpiry'));
                }
                if (getPref('markRevertedPagesAsMinor').indexOf(params.type) !== -1) {
                    revertPage.setMinorEdit(true);
                }
                if (!_this.rollbackInPlace) {
                    Morebits.wiki.actionCompleted.redirect = params.pagename;
                }
                Morebits.wiki.actionCompleted.notice = msg('revert-complete');
                revertPage.revert(_this.callbacks.complete);
            },
            // Only called from main, not from toRevision
            complete: function (pageobj) {
                var params = pageobj.getCallbackParameters();
                if (params.notifyUser && !params.userHidden) {
                    Morebits.status.info('Info', msg('opening-talk', params.user));
                    var windowQuery = {
                        title: 'User talk:' + params.user,
                        action: 'edit',
                        preview: 'yes',
                        vanarticle: params.pagename.replace(/_/g, ' '),
                        vanarticlerevid: params.revid,
                        vantimestamp: params.vantimestamp,
                        vanarticlegoodrevid: params.goodid,
                        type: params.type,
                        count: params.count,
                    };
                    switch (getPref('userTalkPageMode')) {
                        case 'tab':
                            window.open(mw.util.getUrl('', windowQuery), '_blank');
                            break;
                        case 'blank':
                            window.open(mw.util.getUrl('', windowQuery), '_blank', 'location=no,toolbar=no,status=no,directories=no,scrollbars=yes,width=1200,height=800');
                            break;
                        case 'window':
                        /* falls through */
                        default:
                            window.open(mw.util.getUrl('', windowQuery), window.name === 'twinklewarnwindow' ? '_blank' : 'twinklewarnwindow', 'location=no,toolbar=no,status=no,directories=no,scrollbars=yes,width=1200,height=800');
                            break;
                    }
                }
                // review the revert, if needed
                if (params.reviewRevert) {
                    var query = {
                        action: 'review',
                        revid: pageobj.getSaveResponse().edit.newrevid,
                        token: params.csrftoken,
                        comment: msg('pcreview-comment') + Twinkle.summaryAd, // until the below
                        // 'tags': Twinkle.changeTags // flaggedrevs tag support: [[phab:T247721]]
                    };
                    var wikipedia_api = new Morebits.wiki.api(msg('pcreview-accepting'), query);
                    wikipedia_api.post();
                }
            },
        };
        // Only proceed if the user can actually edit the page in question
        // (see #632 for contribs issue).  wgIsProbablyEditable should take
        // care of namespace/contentModel restrictions as well as explicit
        // protections; it won't take care of cascading or TitleBlacklist.
        if (mw.config.get('wgIsProbablyEditable')) {
            // wgDiffOldId included for clarity in if else loop [[phab:T214985]]
            if (mw.config.get('wgDiffNewId') || mw.config.get('wgDiffOldId')) {
                // Reload alongside the revision slider
                mw.hook('wikipage.diff').add(function () {
                    _this.addLinks.diff();
                });
            }
            else if (mw.config.get('wgAction') === 'view' &&
                mw.config.get('wgRevisionId') &&
                mw.config.get('wgCurRevisionId') !== mw.config.get('wgRevisionId')) {
                _this.addLinks.oldid();
            }
            else if (mw.config.get('wgAction') === 'history' && mw.config.get('wgArticleId')) {
                _this.addLinks.history();
            }
        }
        else if (mw.config.get('wgNamespaceNumber') === -1) {
            _this.skipTalk = !getPref('openTalkPageOnAutoRevert');
            _this.rollbackInPlace = getPref('rollbackInPlace');
            if (mw.config.get('wgCanonicalSpecialPageName') === 'Contributions') {
                _this.addLinks.contributions();
            }
            else if (mw.config.get('wgCanonicalSpecialPageName') === 'Recentchanges' ||
                mw.config.get('wgCanonicalSpecialPageName') === 'Recentchangeslinked') {
                // Reload with recent changes updates
                // structuredChangeFilters.ui.initialized is just on load
                mw.hook('wikipage.content').add(function (item) {
                    if (item.is('div')) {
                        _this.addLinks.recentchanges();
                    }
                });
            }
        }
        return _this;
    }
    Fluff.prototype.disableLinks = function (parentNode) {
        // Array.from not available in IE11 :(
        $(parentNode)
            .children()
            .each(function (_ix, node) {
            node.innerHTML = node.textContent; // Feels like cheating
            $(node).css('font-weight', 'normal').css('color', 'darkgray');
        });
    };
    Fluff.prototype.revert = function (type, vandal, rev, page) {
        var _this = this;
        if (mw.util.isIPv6Address(vandal)) {
            vandal = Morebits.ip.sanitizeIPv6(vandal);
        }
        var pagename = page || mw.config.get('wgPageName');
        var revid = rev || mw.config.get('wgCurRevisionId');
        if (this.rollbackInPlace) {
            var notifyStatus = document.createElement('span');
            mw.notify(notifyStatus, {
                autoHide: false,
                title: 'Rollback on ' + page,
                tag: 'twinklefluff_' + rev, // Shouldn't be necessary given disableLink
            });
            Morebits.status.init(notifyStatus);
        }
        else {
            Morebits.status.init(document.getElementById('mw-content-text'));
            $('#catlinks').remove();
        }
        var params = {
            type: type,
            user: vandal,
            userHidden: !vandal,
            pagename: pagename,
            revid: revid,
        };
        // Largely recapitulates Morebits.wiki.page.load, but we want to
        // process multiple revisions as well as discover flagged status
        var query = {
            action: 'query',
            prop: ['info', 'revisions'].concat(this.flaggedRevsEnabled ? 'flagged' : []),
            titles: pagename,
            inprop: 'watched',
            intestactions: 'edit',
            rvlimit: getPref('revertMaxRevisions'),
            rvprop: ['ids', 'timestamp', 'user'],
            curtimestamp: '',
            meta: 'tokens',
            type: 'csrf',
            format: 'json',
        };
        var wikipedia_api = new Morebits.wiki.api(msg('fetching-data'), query);
        wikipedia_api.params = params;
        wikipedia_api.post().then(function (apiobj) { return _this.callbacks.main(apiobj); });
    };
    Fluff.prototype.revertToRevision = function (oldrev) {
        Morebits.status.init(document.getElementById('mw-content-text'));
        // This is only here because we want the fancy edit summary from
        // this.formatSummary, so we need to load the revision user
        // before reverting.  If not for that, we could just skip loading.
        var revertPage = new Morebits.wiki.page(mw.config.get('wgPageName'), msg('saving-reverted'));
        revertPage.setOldID(oldrev);
        revertPage.load(this.callbacks.toRevision);
    };
    // Format a nicer edit summary than the default Morebits revert one, mainly by
    // including user contribs and talk links and appending a custom reason.
    // If builtInString contains the string "%USER%", it will be replaced
    // by an appropriate user link if a user name is provided
    Fluff.prototype.formatSummary = function (builtInString, userName, customString) {
        var result = builtInString;
        // append user's custom reason
        if (customString) {
            result += ': ' + Morebits.string.toUpperCaseFirstChar(customString);
        }
        // find number of UTF-8 bytes the resulting string takes up, and possibly add
        // a contributions or contributions+talk link if it doesn't push the edit summary
        // over the 499-byte limit
        if (/%USER%/.test(builtInString)) {
            if (userName) {
                var resultLen = unescape(encodeURIComponent(result.replace('%USER%', ''))).length;
                var contribsLink = '[[Special:Contributions/' + userName + '|' + userName + ']]';
                var contribsLen = unescape(encodeURIComponent(contribsLink)).length;
                if (resultLen + contribsLen <= 499) {
                    var talkLink = ' ([[User talk:' + userName + '|talk]])';
                    if (resultLen + contribsLen + unescape(encodeURIComponent(talkLink)).length <= 499) {
                        result = Morebits.string.safeReplace(result, '%USER%', contribsLink + talkLink);
                    }
                    else {
                        result = Morebits.string.safeReplace(result, '%USER%', contribsLink);
                    }
                }
                else {
                    result = Morebits.string.safeReplace(result, '%USER%', userName);
                }
            }
            else {
                result = Morebits.string.safeReplace(result, '%USER%', msg('hidden-user'));
            }
        }
        return result;
    };
    Fluff.moduleName = 'fluff';
    return Fluff;
}(TwinkleModule));
export { Fluff as FluffCore };
//# sourceMappingURL=fluffCore.js.map